; Variable transfer routines... takes mem addr to VAT or
; page number to program and does the deed..
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/
;
get_e2:				;
	call &clearmenu		; Clear
	ld hl,$0C00		;
	ld (CURSOR_X),hl	;
	ld hl,&vrec		;
	call D_ZM_STR		;
	ld hl,$1500		;
	ld (CURSOR_X),hl	;
	ld hl,&onpg		;
	call D_ZM_STR		;
	ld hl,$1B00		;
	ld (CURSOR_X),hl	;
	ld hl,&vleft		;
	call D_ZM_STR		;
	ld hl,8			; Get name into buffer1
	ld (numba),hl		;
	ld a,4			;
	ld (pstart),a		;
	ld hl,buffer2		;
	call &get_sfe		;
	ld hl,buffer2		;
	call VAR_GET		; Look for it
	jp nc,&ge2_exists	; Already exists! (Undo extra push)
	ld hl,1			;
	ld (numba),hl		;
	ld a,12			;
	ld (pstart),a		;
	ld hl,type		;
	call &get_sfe		; Get into buffer1 -- Should check for EIIS
	call &get_e2size	; Get size into bc
	ld (size),hl		;
	ld b,h			;
	ld c,l			;
	ld hl,buffer2		;
	ld a,(type)		;
	cp $0C			; 85 Program
	jr z,gete2_prog		;
	cp $0E			;
	jr z,gete2_stng		; 85 String
	ld hl,$302A		;
	ld (CURSOR_X),hl	;
	ld hl,&vunkn		;
	jp &disp_pause_exit	;

; This will all be different on 85, 83
gete2_prog:
	ld a,$12		; Program
	jr fill_variable	;

gete2_stng:
	ld a,$0C		;

fill_variable:
	call VAR_NEW		; Create
	jp c,&exitpause		; Return on error
	ld hl,buffer2		;
	call VAR_GET		; Find data location
	ld (datptr),hl		; Where to write data to

	ld a,1			; We have a variable if we're still here..
	ld (varactive),a	;

	ld hl,(size)		;
	ld bc,0250		;
	or a
	sbc hl,bc		;
	jr c,get_one_page	; File is under 1 EEPROM page, get one, exit
	inc hl			;
	ld (size),hl		; We're only getting 249, not 250
	ld a,15			;  
	ld (pstart),a		;
	ld hl,249		;
	ld (numba),hl		;
	ld hl,(datptr)		;
	call &get_sfe		; Get with bigass pointer (pain in ass)
	ld (datptr),hl		;
get_more:			;
	call &update_e2var	; Update display
	ld hl,(page)		;
	inc hl			; Move to next page
	ld (page),hl		; 
	ld hl,(size)		;
	ld bc,261		;
	or a			;
	sbc hl,bc		;
	jr c,get_last_page	; Get last page of file
	inc hl			; we're only taking 260 now
	ld (size),hl		;
	ld hl,260		;
	ld (numba),hl		;
	ld a,4			;
	ld (pstart),a		;
	ld hl,(datptr)		;
	call &get_sfe		; Get with long pointer
	ld (datptr),hl		;
	jr get_more		; Keep going till done

get_one_page:			;
	ld a,15			;
	ld (pstart),a		;
	jr get_the_page		;
get_last_page:			;
	ld a,4			;
	ld (pstart),a		;
get_the_page:
	ld hl,(size)		;
	ld (numba),hl		;
	ld hl,(datptr)		;
	call &get_sfe		; Get the puppy
	xor a			; Successful if we're still here
	ld (varactive),a	;
	ld hl,buffer2		; Clear buffer1
	ld b,9			;
	call &zeromem		;
	ld hl,$302A		;
	ld (CURSOR_X),hl	;
	ld hl,&vrecd		;
	jp &disp_pause_exit	;

; Calculate name length for VAT calls
;calc_nl:
;	ld hl,buffer2		;
;	ld b,0			;
;calc_nl_loop:
;	ld a,(hl)		;
;	or a			; Count till zero
;	ret z			;
;	inc hl			;
;	inc b			;
;	jr calc_nl_loop		;

put_e2:				;
	push hl			; VAT addr
	push hl			; Save it a few times
	call &clearmenu		;
	ld hl,$0C00		;
	ld (CURSOR_X),hl	;
	ld hl,&vsend		;
	call D_ZM_STR		;
	ld hl,$1500		;
	ld (CURSOR_X),hl	;
	ld hl,&onpg		;
	call D_ZM_STR		;
	ld hl,$1B00		;
	ld (CURSOR_X),hl	;
	ld hl,&vleft		;
	call D_ZM_STR		;
	ld hl,buffer1		; Clear buffer
	ld b,9			;
	call &zeromem		;
	pop hl			;
	ld bc,-$03		;
	add hl,bc		; Point at name length byte
	ld b,(hl)		; Put name length into b
	dec hl			; Move to beginning of name
	ld de,buffer1		; Store in buffer1
	call &dnloop		; Copy to buffer1, right way (backwards VAT)
	call &find_first_free	; Setup page to write to
	jp c,&pe2_exists	;
	ld hl,264		;
	ld (numba),hl		;
	xor a			;
	ld (pstart),a		;
	call &send_sfe		; Setup chip for data
	ld bc,4			; Send four byte security code
	ld hl,secs		; Start page
	call &ssfe_loop		; Send it...
	ld bc,8			; Always send 8 bytes for name... 0 padded
	ld hl,buffer1		;
	call &ssfe_loop		; Send it to EEPROM
	pop hl			; Get hl back
	ld a,(hl)		; Type byte...
	cp $12			; Program
	jr z,put_e2_prog	;
	cp $0C			;
	jr z,put_e2_stng	;
	ld hl,$302A		;
	ld (CURSOR_X),hl	;
	ld hl,&vunkn		;
	jp &disp_pause_exit	;

put_e2_prog:
	ld a,$0C		; 85 Program type
	jr send_type_byte	;
put_e2_stng:
	ld a,$0E		; 85 String type
send_type_byte:
	di			; Disable interrupts
	call &send_byte		; Send byte
	ei			;
	dec hl			; Keep using same hl...
	ld e,(hl)		;
	dec hl			;  MidSB address byte...
	ld d,(hl)		;
	ex de,hl		; Overwrite hl now that its pushed
	push hl			;
	call LD_HL_MHL		;
	ld (size),hl		;
	pop hl			;
	inc hl			; Increase over size word
	inc hl			;
	ld (datptr),hl		; Backup pointer
	ld hl,(size)		;
	ld a,h			; Send size to EEPROM...
	di			;
	call &send_byte		;
	ld a,l			;
	call &send_byte		;
	ei			;
	ld bc,0250		;
	or a			;
	sbc hl,bc		;
	jp c,&one_page_total	; Put last page (pad if needed)
	inc hl			; Subtract 249
	ld (size),hl		;
	ld bc,249		; We'll be sending that many
	ld hl,(datptr)		;
	call &ssfe_loop		; Send em
	ld (datptr),hl		; Store back... (loop handles paging)

send_big_loop:
	call &update_e2var	; Update UI
	call &e2_dlay		; Give it time to write
	ld hl,(page)		; On to next page
	inc hl			;
	ld (page),hl		;
	ld hl,0264		;
	ld (numba),hl		;
	xor a			;
	ld (pstart),a		;
	call &send_sfe		;
	ld bc,4			;
	ld hl,secc		; Send four security code bytes
	call &ssfe_loop		;
	ld hl,(size)		;
	ld bc,0261		;
	or a			;
	sbc hl,bc		;
	jr c,put_one_more	;
	inc hl			; Subtract 260...
	ld (size),hl		;
	ld hl,(datptr)		;
	ld bc,260		; Send 260...
	call &ssfe_loop		; Send 260 bytes using ahl
	ld (datptr),hl		;
	jr send_big_loop	; Keep doing 260 at a time...

put_one_more:
	ld bc,(size)		; Number left... less than or = 260
	ld hl,(datptr)		;
	call &ssfe_loop		;
	ld de,(size)		;
	ld hl,0260		;
	or a			;
	sbc hl,de		;
	ld b,h			;
	ld c,l			;
	call &erasep_ldi	; Pad with $FFs
	jr exit_pe2		; Bail

one_page_total:
	ld bc,(size)		;
	ld hl,(datptr)		;
	call &ssfe_loop		;
	ld de,(size)		;
	ld hl,0249		;
	or a			;
	sbc hl,de		;
	ld b,h			;
	ld c,l			;
	call &erasep_ldi	;

exit_pe2:
	ld hl,$302A		;
	ld (CURSOR_X),hl	;
	ld hl,&vsent		;
disp_pause_exit:
	call D_ZM_STR		; Overwrite previous
	jp &exitpause		; Return, pausing before... stack ok

pe2_exists:
	inc sp			; Undo push hl
	inc sp			;
ge2_exists:
	ld hl,$302A		;
	ld (CURSOR_X),hl	;
	ld hl,&vexists		;
	jr disp_pause_exit	;

; Scans for a file/end of space
; Returns with z set if last page found
; Returns with c set if page of variable found	
find_first_free:
	ld de,0			; Start at 0...
	ld (page),de		;
find_ff_loop:
	ld hl,8			; And now name
	ld (numba),hl		;
	ld a,4			;
	ld (pstart),a		;
	ld hl,buffer2		;
	call &get_sfe		;
	call &cmp_buf1_buf2	; Compare with name from user
	ret c			; If there is a match, carry set; return
	call &get_e2size	; Get size
	ld a,l			; Are both size bytes $FF?
	and h			;
	cp $FF			; If it is, this is a blank page...
	ret z			; Return, we found last page
	call &mv2nextsp		; Check next page...
	jr find_ff_loop		;	

cmp_buf1_buf2:			; Check if buffer1/buffer2 are equal
	ld b,8			; compare 8 bytes
	ld hl,buffer1		;
	ld de,buffer2		;
cmp_loop:
	ld a,(de)		;
	ld c,(hl)		;
	cp c			;
	jr nz,no_match		; Only takes one to make them different..
	inc hl			;
	inc de			;
	djnz cmp_loop		; ... Takes 8 to make them same
	scf			; They match... return with carry set
	ret			;

no_match:
	or a			; Return with carry cleared
	ret			;

update_e2var:
	ld hl,$152A		;
	push hl
	ld (CURSOR_X),hl	;
	ld hl,&space		;
	call D_ZM_STR		; Overwrite previous
	pop hl			;
	ld (CURSOR_X),hl	;
	ld hl,(page)		; Page we're on now...
	call &vputHL		; Display it
	ld hl,$1B2A		;
	push hl
	ld (CURSOR_X),hl	;
	ld hl,&space		;
	call D_ZM_STR		; Overwrite previous
	ld hl,$1B30		;
	ld (CURSOR_X),hl	;
	ld hl,&space		;
	call D_ZM_STR		;
	pop hl			;
	ld (CURSOR_X),hl	;
	ld hl,(size)		; Page we're on now...
	jp &vputHL		; Display it
